//+------------------------------------------------------------------+
//|                                              RandomWalkMulti.mq5 |
//|                                   Copyright 2011, Grebenev Slava |
//|                                         http://grebenev.narod.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright 2011, Grebenev Slava"
//---
#define OrderNumberEURUSD 1
//--- input parameters
input int random=12345;      //         
input int time=350000;       //   
input int purpose=100000;    //    
//---
enum lastdeal {no,buy,sell}; //   ,      -   
lastdeal ld=no;
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
   SymbolSelect("EURUSD",true);
//---    , ..  -
   MathSrand(random);
//---  ,  
   Start();
   return(0);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
   return;
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//|                                              |
//+------------------------------------------------------------------+
void OnTick()
  {
   double balance=AccountInfoDouble(ACCOUNT_BALANCE);
   double equity=AccountInfoDouble(ACCOUNT_EQUITY);
//---   
   if(AccountInfoDouble(ACCOUNT_MARGIN_LEVEL)<55.0)
     {
      Stop();
      Start();
     };
//---  , 33000   
   if(equity-balance>33000)
     {
      Stop();
      Start();
     }
//---  , 2   
   if(equity>2*balance)
     {
      Stop();
      Start();
     };
//---  ,   ,  
   if(equity>purpose)
     {
      Stop();
      TerminalClose(0);
     };
//---  ,  ,  , 
//--- 150        0.1       
   if(balance<150)
     {
      Stop();
      TerminalClose(0);
     };
   return;
  }
//+------------------------------------------------------------------+
//| Timer function                                                   |
//|      .                |
//+------------------------------------------------------------------+
void OnTimer()
  {
//---  
   Stop();
//---  
   Start();
   return;
  }
//+------------------------------------------------------------------+
//| Direction                                                        |
//|     .                              |
//|         .      |
//+------------------------------------------------------------------+
bool Direction()
  {
//---      
   bool r=(rand()>32768/2);
   return(r);
  }
//+------------------------------------------------------------------+
//| Start                                                            |
//|                                           |
//+------------------------------------------------------------------+
void Start()
  {
   double balance=0;
   double free_margin=0;
   double bet=0;
//---        
   if(Direction())
     {
      free_margin=AccountInfoDouble(ACCOUNT_FREEMARGIN);
      balance=AccountInfoDouble(ACCOUNT_BALANCE);
      //---   , 1.7   EURUSD,  1:100
      bet=free_margin/1000/1.7;
      //---    0.01
      bet=round(bet*100)/100;
      //---    
      if(bet<0.1) bet=0.1;
      //---    
      if(bet>5) bet=5;
      SendBuyOrderEURUSD(bet);
      ld=buy;
      //---  
      EventSetTimer(time);
     }
   else
     {
      free_margin=AccountInfoDouble(ACCOUNT_FREEMARGIN);
      balance=AccountInfoDouble(ACCOUNT_BALANCE);
      //---   , 1.7   EURUSD,  1:100
      bet=free_margin/1000/1.7;
      //---    0.01
      bet=round(bet*100)/100;
      //---    
      if(bet<0.1) bet=0.1;
      //---    
      if(bet>5) bet=5;
      SendSellOrderEURUSD(bet);
      ld=sell;
      //---  
      EventSetTimer(time);
     }
   return;
  }
//+------------------------------------------------------------------+
//| Stop                                                             |
//|                                            |
//+------------------------------------------------------------------+
void Stop()
  {
   double pv=0;
//---  ,  
   if(ld==buy)
     {
      if(PositionSelect("EURUSD"))
        {
         pv=PositionGetDouble(POSITION_VOLUME);
         if(pv>0) SendSellOrderEURUSD(pv);
         pv=0;
        };
      EventKillTimer(); ld=no;
     };

   if(ld==sell)
     {
      if(PositionSelect("EURUSD"))
        {
         pv=PositionGetDouble(POSITION_VOLUME);
         if(pv>0) SendBuyOrderEURUSD(pv);
         pv=0;
        };
      EventKillTimer();
      ld=no;
     };
//       100 000   100 .
// int ret_code=0;
// if (AccountInfoDouble(ACCOUNT_BALANCE)<100) TerminalClose(ret_code);
// if (AccountInfoDouble(ACCOUNT_BALANCE)>100000) TerminalClose(ret_code);
   return;
  }
//+------------------------------------------------------------------+
//| SendBuyOrderEURUSD                                               |
//|   EURUSD                                           |
//+------------------------------------------------------------------+
void SendBuyOrderEURUSD(double Bet)
  {
   MqlTick last_tick;
   if(SymbolInfoTick("EURUSD",last_tick))
     {
      MqlTradeRequest request;
      //---  
      //---       ( )
      request.action=TRADE_ACTION_DEAL;
      //--- ORDER_MAGIC
      request.magic=OrderNumberEURUSD;
      //--- 
      request.symbol="EURUSD";
      //--- 
      request.volume=Bet;
      //--- 
      request.price=last_tick.ask;
      //--- Stop Loss  
      request.sl=0;
      //--- Take Profit  
      request.tp=0;
      //---  
      request.type=ORDER_TYPE_BUY;
      MqlTradeResult result;
      MqlTradeCheckResult CheckResult;
      //---  
      if(OrderCheck(request,CheckResult)) OrderSend(request,result);
      else Print(CheckResult.retcode,"  ",SymbolInfoDouble("EURUSD",SYMBOL_VOLUME_MAX));
      //---       
      Print(__FUNCTION__,":",result.comment);
     }
   else Print("SymbolInfoTick() failed, error = ",GetLastError());
   return;
  }
//+------------------------------------------------------------------+
//| SendSellOrderEURUSD                                              |
//|   EURUSD                                           |
//+------------------------------------------------------------------+
void SendSellOrderEURUSD(double Bet)
  {
   MqlTick last_tick;
   if(SymbolInfoTick("EURUSD",last_tick))
     {
      //---  
      MqlTradeRequest request;
      //---       ( )
      request.action=TRADE_ACTION_DEAL;
      //--- ORDER_MAGIC
      request.magic=OrderNumberEURUSD;
      //--- 
      request.symbol="EURUSD";
      //---  
      request.volume=Bet;
      request.price=last_tick.bid;
      //--- Stop Loss  
      request.sl=0;
      //--- Take Profit  
      request.tp=0;
      //---  
      request.type=ORDER_TYPE_SELL;
      MqlTradeResult result;
      MqlTradeCheckResult CheckResult;
      //---   
      if(OrderCheck(request,CheckResult)) OrderSend(request,result);
      else Print(CheckResult.retcode,"  ",SymbolInfoDouble("EURUSD",SYMBOL_VOLUME_MAX));
      //---       
      Print(__FUNCTION__,":",result.comment);
      if(result.retcode==10016) Print(result.bid,result.ask,result.price);
     }
   else Print("SymbolInfoTick() failed, error = ",GetLastError());
   return;
  }

//+------------------------------------------------------------------+
